specification sender 

clocks : x;
vars : i, p, dz;
events : ;
internals : ; 
orders : up, down;

initially Idle, {x := 0, p := 0, dz := 0};

location Idle : 
    {x >= 12}, up, {x := 0, p := 0, dz := 0}, OneSent;
      
location OneSent :
    {x = 2, i = 1}, down, {x := 0}, WaitOne;
    {x = 4, i = 0}, down, {x := 0, p := 1-p}, ZeroSent; 
    {p = 1}, down, {x := 0}, Idle;
   
location WaitOne : 
    {x = 2}, up, {x := 0, p := 1-p}, OneSent;   
	
location ZeroSent : 
    {x = 2, i = 0}, up, {x := 0}, WaitZero;
    {x = 4, i = 1}, up, {x := 0, p := 1-p, dz := 0}, OneSent; 
    {p = 1}, down, {x := 0}, Idle;
    {dz = 1}, down, {x := 0}, Idle;

location WaitZero : 
    {x = 2}, down, {x := 0, p := 1-p, dz := 1}, ZeroSent;

end

decoration sender 

global
{%   
    #define DATA_REGISTER   0x378
    #define CTRL_REGISTER   0x37A
    #define GOOD_INDEX      (0 <= data_index && data_index < data_length)
    int var_p, var_dz, data_index;
    int data[] =
    {   1, 1, 1, 1, 1, 1, 1, 1,    1, 0, 1, 0, 1, 0, 1, 1,
        1, 0, 1, 0, 1, 1, 1, 1,    1, 0, 1, 0, 1, 0, 1, 1,
        1, 0, 1, 1, 1, 0, 1, 1,    1, 0, 1, 0, 1, 0, 1, 1,
        1, 1, 1, 0, 1, 0, 1, 1,    1, 1, 1, 1, 1, 1, 1, 1,    0, 0   
    };
    const int data_length = 8*8+2;
    int sequence_finished(void) {return data_index >= data_length;}
%}

order up   {% outb(255, DATA_REGISTER); %} nop
order down {% outb(0,   DATA_REGISTER); %} nop

startup {% outb(0, CTRL_REGISTER); outb(0, DATA_REGISTER); %}
cleanup nop

reading i          {% return GOOD_INDEX ? data[data_index] : 0; %}
reading p          {% return var_p;                             %}
writing p (value)  {% var_p = value;                            %}
reading dz         {% return var_dz;                            %}
writing dz (value) {% var_dz = value;                           %}

Idle     to OneSent   {% data_index = 0;      %}     nop
WaitOne  to OneSent   {% data_index++;        %}     nop    
ZeroSent to OneSent   {% data_index++;        %}     nop 
any      to ZeroSent  {% data_index++;        %}     nop 
any      to Idle      {% spectre_running = 0; %}     nop  

restrict any to Idle        {% return  sequence_finished();  %}
restrict any to WaitZero    {% return !sequence_finished();  %}
restrict any to WaitOne     {% return !sequence_finished();  %}
restrict any to ZeroSent    {% return !sequence_finished();  %}

end
