/* RTAI includes ------------------------------------------------------------ */
#include <linux/module.h>
#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_sem.h>
#include <rtai_fifos.h>

/* user defines ------------------------------------------------------------- */
#define TIME_UNIT   <define this>
#define WIDENER     <define this>
#define PERIOD      <define this>
#define BEAT        <define this>

/* system defines ----------------------------------------------------------- */
#define STACK_SIZE 10000
#define USE_FPU 1

/* global decoration -------------------------------------------------------- */

#define TRUE 1
#define FALSE 0

#define BASE_ADDRESS	0x378
#define DATA_REGISTER	(BASE_ADDRESS)
#define STAT_REGISTER	(BASE_ADDRESS + 1)
#define CTRL_REGISTER	(BASE_ADDRESS + 2)

int var_p, var_doublezero;
int data[] = {
  1, 1, 1, 1, 1, 1, 1, 1,
  1, 0, 1, 0, 1, 0, 1, 1,
  1, 0, 1, 0, 1, 1, 1, 1,
  1, 0, 1, 0, 1, 0, 1, 1,
  1, 0, 1, 1, 1, 0, 1, 1,
  1, 0, 1, 0, 1, 0, 1, 1,
  1, 1, 1, 0, 1, 0, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1,
  0, 0
};
const int data_length = 8 * 8 + 2;
int data_index;

int
sequence_finished ()
{
  return data_index >= data_length;
}


/* spectre gobals ----------------------------------------------------------- */
RTIME spectre_clock_x;

int spectre_equals (RTIME a, RTIME b);
int spectre_biggerthan (RTIME a, RTIME other);
int spectre_smallerthan (RTIME a, RTIME other);
void spectre_task_main (int data);
void (*spectre_current_location) (void);
RTIME spectre_current_time;
int spectre_running;

/* variables readings headers ----------------------------------------------- */
int spectre_read_i ();
int spectre_read_p ();
int spectre_read_doublezero ();

/* clocks readings headers -------------------------------------------------- */
RTIME spectre_read_x ();


/* variables writings headers ----------------------------------------------- */
void spectre_write_i (int value);
void spectre_write_p (int value);
void spectre_write_doublezero (int value);

/* clocks writings headers -------------------------------------------------- */
void spectre_write_x (RTIME value);


/* orders headers ----------------------------------------------------------- */
void spectre_order_up (void);
void spectre_order_down (void);

/* internals headers -------------------------------------------------------- */

/* events headers ----------------------------------------------------------- */

/* location headers --------------------------------------------------------- */
void spectre_location_idle (void);
void spectre_location_oneSent (void);
void spectre_location_waitingOne (void);
void spectre_location_zeroSent (void);
void spectre_location_waitingZero (void);

/* transitions headers ------------------------------------------------------ */
void spectre_transition_initially (void);
void spectre_transition_idle_to_oneSent_1 (void);
void spectre_transition_oneSent_to_waitingOne_1 (void);
void spectre_transition_oneSent_to_zeroSent_2 (void);
void spectre_transition_oneSent_to_idle_3 (void);
void spectre_transition_waitingOne_to_oneSent_1 (void);
void spectre_transition_zeroSent_to_waitingZero_1 (void);
void spectre_transition_zeroSent_to_oneSent_2 (void);
void spectre_transition_zeroSent_to_idle_3 (void);
void spectre_transition_zeroSent_to_idle_4 (void);
void spectre_transition_waitingZero_to_zeroSent_1 (void);

/* guards headers ----------------------------------------------------------- */
int spectre_guard_idle_to_oneSent_1 (void);
int spectre_guard_oneSent_to_waitingOne_1 (void);
int spectre_guard_oneSent_to_zeroSent_2 (void);
int spectre_guard_oneSent_to_idle_3 (void);
int spectre_guard_waitingOne_to_oneSent_1 (void);
int spectre_guard_zeroSent_to_waitingZero_1 (void);
int spectre_guard_zeroSent_to_oneSent_2 (void);
int spectre_guard_zeroSent_to_idle_3 (void);
int spectre_guard_zeroSent_to_idle_4 (void);
int spectre_guard_waitingZero_to_zeroSent_1 (void);

/* checks headers ----------------------------------------------------------- */
int spectre_check_idle_to_oneSent_1 (void);
int spectre_check_oneSent_to_waitingOne_1 (void);
int spectre_check_oneSent_to_zeroSent_2 (void);
int spectre_check_oneSent_to_idle_3 (void);
int spectre_check_waitingOne_to_oneSent_1 (void);
int spectre_check_zeroSent_to_waitingZero_1 (void);
int spectre_check_zeroSent_to_oneSent_2 (void);
int spectre_check_zeroSent_to_idle_3 (void);
int spectre_check_zeroSent_to_idle_4 (void);
int spectre_check_waitingZero_to_zeroSent_1 (void);

/* decorations headers ------------------------------------------------------ */
void spectre_d1_idle_to_oneSent (void);
void spectre_d1_oneSent_to_idle (void);
void spectre_d1_oneSent_to_waitingOne (void);
void spectre_d1_oneSent_to_zeroSent (void);
void spectre_d1_waitingOne_to_oneSent (void);
void spectre_d1_zeroSent_to_idle (void);
void spectre_d1_zeroSent_to_oneSent (void);
void spectre_d1_zeroSent_to_waitingZero (void);
void spectre_d1_waitingZero_to_zeroSent (void);

void spectre_d2_idle_to_oneSent (void);
void spectre_d2_oneSent_to_idle (void);
void spectre_d2_oneSent_to_waitingOne (void);
void spectre_d2_oneSent_to_zeroSent (void);
void spectre_d2_waitingOne_to_oneSent (void);
void spectre_d2_zeroSent_to_idle (void);
void spectre_d2_zeroSent_to_oneSent (void);
void spectre_d2_zeroSent_to_waitingZero (void);
void spectre_d2_waitingZero_to_zeroSent (void);

void spectre_d1_any_to_idle (void);
void spectre_d1_any_to_oneSent (void);
void spectre_d1_any_to_waitingOne (void);
void spectre_d1_any_to_zeroSent (void);
void spectre_d1_any_to_waitingZero (void);

void spectre_d2_any_to_idle (void);
void spectre_d2_any_to_oneSent (void);
void spectre_d2_any_to_waitingOne (void);
void spectre_d2_any_to_zeroSent (void);
void spectre_d2_any_to_waitingZero (void);

void spectre_d1_idle_to_any (void);
void spectre_d1_oneSent_to_any (void);
void spectre_d1_waitingOne_to_any (void);
void spectre_d1_zeroSent_to_any (void);
void spectre_d1_waitingZero_to_any (void);

void spectre_d2_idle_to_any (void);
void spectre_d2_oneSent_to_any (void);
void spectre_d2_waitingOne_to_any (void);
void spectre_d2_zeroSent_to_any (void);
void spectre_d2_waitingZero_to_any (void);

void spectre_d1_any_to_any (void);
void spectre_d2_any_to_any (void);


/* restrictions headers ----------------------------------------------------- */
int spectre_r_idle_to_oneSent (void);
int spectre_r_oneSent_to_idle (void);
int spectre_r_oneSent_to_waitingOne (void);
int spectre_r_oneSent_to_zeroSent (void);
int spectre_r_waitingOne_to_oneSent (void);
int spectre_r_zeroSent_to_idle (void);
int spectre_r_zeroSent_to_oneSent (void);
int spectre_r_zeroSent_to_waitingZero (void);
int spectre_r_waitingZero_to_zeroSent (void);

int spectre_r_any_to_idle (void);
int spectre_r_any_to_oneSent (void);
int spectre_r_any_to_waitingOne (void);
int spectre_r_any_to_zeroSent (void);
int spectre_r_any_to_waitingZero (void);

int spectre_r_idle_to_any (void);
int spectre_r_oneSent_to_any (void);
int spectre_r_waitingOne_to_any (void);
int spectre_r_zeroSent_to_any (void);
int spectre_r_waitingZero_to_any (void);

int spectre_r_any_to_any (void);

/* variables readings implementation ---------------------------------------- */
int
spectre_read_i ()
{
  return data[data_index];
}

int
spectre_read_p ()
{
  return var_p;
}

int
spectre_read_doublezero ()
{
  return var_doublezero;
}

/* clocks readings implementation ------------------------------------------- */
RTIME
spectre_read_x ()
{
  return spectre_current_time - spectre_clock_x;
}


/* variables writings implementation ---------------------------------------- */
void
spectre_write_i (int foo)
{;
}

void
spectre_write_p (int value)
{
  var_p = value;
}

void
spectre_write_doublezero (int value)
{
  var_doublezero = value;
}

/* clocks writings implementation ------------------------------------------- */
void
spectre_write_x (RTIME newtime)
{
  spectre_clock_x = spectre_current_time - newtime;
}


/* decorations implementation ----------------------------------------------- */
void
spectre_d1_idle_to_oneSent ()
{;
}

void
spectre_d1_oneSent_to_idle ()
{;
}

void
spectre_d1_oneSent_to_waitingOne ()
{;
}

void
spectre_d1_oneSent_to_zeroSent ()
{;
}

void
spectre_d1_waitingOne_to_oneSent ()
{;
}

void
spectre_d1_zeroSent_to_idle ()
{;
}

void
spectre_d1_zeroSent_to_oneSent ()
{;
}

void
spectre_d1_zeroSent_to_waitingZero ()
{;
}

void
spectre_d1_waitingZero_to_zeroSent ()
{;
}

void
spectre_d2_idle_to_oneSent ()
{;
}

void
spectre_d2_oneSent_to_idle ()
{;
}

void
spectre_d2_oneSent_to_waitingOne ()
{;
}

void
spectre_d2_oneSent_to_zeroSent ()
{;
}

void
spectre_d2_waitingOne_to_oneSent ()
{;
}

void
spectre_d2_zeroSent_to_idle ()
{;
}

void
spectre_d2_zeroSent_to_oneSent ()
{;
}

void
spectre_d2_zeroSent_to_waitingZero ()
{;
}

void
spectre_d2_waitingZero_to_zeroSent ()
{;
}

void
spectre_d1_any_to_idle ()
{;
}

void
spectre_d1_any_to_oneSent ()
{;
}

void
spectre_d1_any_to_waitingOne ()
{;
}

void
spectre_d1_any_to_zeroSent ()
{;
}

void
spectre_d1_any_to_waitingZero ()
{;
}

void
spectre_d2_any_to_idle ()
{
  running = FALSE;
}

void
spectre_d2_any_to_oneSent ()
{
  data_index++;
}

void
spectre_d2_any_to_waitingOne ()
{;
}

void
spectre_d2_any_to_zeroSent ()
{
  data_index++;
}

void
spectre_d2_any_to_waitingZero ()
{;
}

void
spectre_d1_idle_to_any ()
{;
}

void
spectre_d1_oneSent_to_any ()
{;
}

void
spectre_d1_waitingOne_to_any ()
{;
}

void
spectre_d1_zeroSent_to_any ()
{;
}

void
spectre_d1_waitingZero_to_any ()
{;
}

void
spectre_d2_idle_to_any ()
{
  data_index = 0;
}

void
spectre_d2_oneSent_to_any ()
{;
}

void
spectre_d2_waitingOne_to_any ()
{;
}

void
spectre_d2_zeroSent_to_any ()
{;
}

void
spectre_d2_waitingZero_to_any ()
{;
}

void
spectre_d1_any_to_any ()
{;
}

void
spectre_d2_any_to_any ()
{;
}


/* guards implementation ---------------------------------------------------- */
int
spectre_guard_idle_to_oneSent_1 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (12 * TIME_UNIT);
  tmp = spectre_largerthan (spectre_t1, spectre_t2);
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_oneSent_to_waitingOne_1 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (2 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  spectre_e1 = spectre_read_i ();
  spectre_e2 = 1;
  tmp = spectre_e1 == spectre_e2;
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_oneSent_to_zeroSent_2 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (4 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  spectre_e1 = spectre_read_i ();
  spectre_e2 = 0;
  tmp = spectre_e1 == spectre_e2;
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_oneSent_to_idle_3 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (2 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  spectre_e1 = spectre_read_p ();
  spectre_e2 = 1;
  tmp = spectre_e1 == spectre_e2;
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_waitingOne_to_oneSent_1 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (2 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_zeroSent_to_waitingZero_1 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (2 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  spectre_e1 = spectre_read_i ();
  spectre_e2 = 0;
  tmp = spectre_e1 == spectre_e2;
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_zeroSent_to_oneSent_2 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (4 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  spectre_e1 = spectre_read_i ();
  spectre_e2 = 1;
  tmp = spectre_e1 == spectre_e2;
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_zeroSent_to_idle_3 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (2 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  spectre_e1 = spectre_read_p ();
  spectre_e2 = 1;
  tmp = spectre_e1 == spectre_e2;
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_zeroSent_to_idle_4 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (2 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  spectre_e1 = spectre_read_doublezero ();
  spectre_e2 = 1;
  tmp = spectre_e1 == spectre_e2;
  res = tmp && res;
  return spectre_res;
}

int
spectre_guard_waitingZero_to_zeroSent_1 ()
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (2 * TIME_UNIT);
  tmp = spectre_equals (spectre_t1, spectre_t2);
  res = tmp && res;
  return spectre_res;
}

/* restrictions implementation ---------------------------------------------- */
int
spectre_r_idle_to_oneSent ()
{
  return 1;
}

int
spectre_r_oneSent_to_idle ()
{
  return 1;
}

int
spectre_r_oneSent_to_waitingOne ()
{
  return !sequence_finished ();
}

int
spectre_r_oneSent_to_zeroSent ()
{
  return 1;
}

int
spectre_r_waitingOne_to_oneSent ()
{
  return 1;
}

int
spectre_r_zeroSent_to_idle ()
{
  return 1;
}

int
spectre_r_zeroSent_to_oneSent ()
{
  return 1;
}

int
spectre_r_zeroSent_to_waitingZero ()
{
  return !sequence_finished ();
}

int
spectre_r_waitingZero_to_zeroSent ()
{
  return 1;
}

int
spectre_r_any_to_idle ()
{
  return sequence_finished ();
}

int
spectre_r_any_to_oneSent ()
{
  return 1;
}

int
spectre_r_any_to_waitingOne ()
{
  return 1;
}

int
spectre_r_any_to_zeroSent ()
{
  return 1;
}

int
spectre_r_any_to_waitingZero ()
{
  return 1;
}

int
spectre_r_idle_to_any ()
{
  return 1;
}

int
spectre_r_oneSent_to_any ()
{
  return 1;
}

int
spectre_r_waitingOne_to_any ()
{
  return 1;
}

int
spectre_r_zeroSent_to_any ()
{
  return 1;
}

int
spectre_r_waitingZero_to_any ()
{
  return 1;
}

int
spectre_r_any_to_any ()
{				/* just a test */
  return 1;
}
