#include "sender.h"

/* spectre globals ---------------------------------------------------------- */

int AASAP_equals(RTIME a, RTIME b)
{
	RTIME lower = b - WIDENER;
	RTIME higher = b + WIDENER;
	return (a > lower && a < higher);
}

int AASAP_biggerthan(RTIME a, RTIME other)
{
	other -= WIDENER;
	return (a > other);
}

int AASAP_smallerthan(RTIME a, RTIME other)
{
	other += WIDENER;
	return (a < other);
}

/* readings implementation -------------------------------------------------- */

int sender_read_i()
{
    return data[data_index];
}

int sender_read_p()
{
    return var_p;
}

int sender_read_doublezero()
{
    return var_doublezero;
}

/* writings implementation -------------------------------------------------- */

void sender_write_p(int value)
{
    var_p = value;
}

void sender_write_doublezero(int value)
{
    var_doublezero = value;
}

/* transitions implementation ----------------------------------------------- */ 

void sender_transition_initially(void)
{
    clock_x = rt_get_time();
    sender_write_p(0);
    sender_write_doublezero(0);
    
    current_location = sender_location_idle;
}

void sender_transition_idle_to_oneSent_1(void)
{
    order_up();    
    
    decoration_idle_to_oneSent_pre(void);
    decoration_idle_to_any_pre(void);
    decoration_any_to_oneSent_pre(void);
    decoration_any_to_any_pre(void);
    
    clock_x = rt_get_time();
    sender_write_p(1);

    decoration_idle_to_oneSent_post(void);
    decoration_idle_to_any_post(void);
    decoration_any_to_oneSent_post(void);
    decoration_any_to_any_post(void);
    
    current_location = sender_location_oneSent;
}

// etc.

/* checks implementation ---------------------------------------------------- */

int sender_check_idle_oneSent_1(void)
{
    int r1,r2,r3,r4,g;

    r1 = sender_restrict_idle_to_oneSent();
    r2 = sender_restrict_idle_to_any();
    r3 = sender_restrict_any_to_oneSent();
    r4 = sender_restrict_any_to_any();

    g = sender_guard_idle_to_oneSent();

    return (g && r1 && r2 && r3 && r4);
}

int sender_check_oneSent_to_waitingOne_1(void)

    int r1,r2,r3,r4,g;

    r1 = sender_restrict_oneSent_to_waitingOne();
    r2 = sender_restrict_oneSent_to_any();
    r3 = sender_restrict_any_to_waitingOne();
    r4 = sender_restrict_any_to_any();

    g = sender_guard_oneSent_to_waitingOne_1();

    return (g && r1 && r2 && r3 && r4);
}

/* locations implementation ------------------------------------------------- */

void sender_location_idle(void)
{
    if(sender_check_idle_oneSent_1)
        sender_transition_idle_oneSent();       
}

void sender_location_oneSent(void)
{
    if(sender_check_oneSent_waitinOne_1())
        sender_transition_oneSent_waitingOne();

    if(sender_check_oneSent_zeroSent_2())
        sender_transition_oneSent_waitingOne();

    if(sender_check_oneSent_idle_3())
        sender_transition_oneSent_waitingOne();
}


/* main function implementation --------------------------------------------- */

static void sender_task_main(int data)
{
	running = TRUE;
	sender_transition_initially();
        
	while (running) {
        current_time = rt_get_time();
        // TODO : check for events !!!
		current_location();
		rt_task_wait_period();
	}
}

/* kernel module functions ---------------------------------------------------*/

int sender_init_module(void)
{
    rt_set_periodic_mode();
	start_rt_timer(BEAT);
	
	sender_startup();
	
	rt_task_init (&sender_task, sender_task_main, 0, STACK_SIZE, TASK_PRIORITY, USE_FPU, 0);
	rt_task_make_periodic(&sender_task, rt_get_time() + PERIOD, PERIOD);

	return 0;
}

void sender_cleanup_module(void)
{
	stop_rt_timer();
	rt_task_delete(&task);
	
	sender_cleanup();
}

module_init(sender_init_module);
module_exit(sender_cleanup_module);
MODULE_LICENSE("GPL");


