/* RTAI includes ------------------------------------------ */
#include <linux/module.h>
#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_sem.h>
#include <rtai_fifos.h>

/* user defines ------------------------------------------- */
#define TIME_UNIT   <define this>
#define WIDENER     <define this>
#define PERIOD      <define this>
#define BEAT        <define this>

/* system defines ----------------------------------------- */
#define STACK_SIZE 10000
#define USE_FPU 1
#define TASK_PRIORITY 128	/* 0 = highest, 255 = lowest */

/* global decoration -------------------------------------- */

#define DATA_REGISTER   0x378
#define CTRL_REGISTER   0x37A
#define GOOD_INDEX      (0 <= data_index && data_index < data_length-1)
const int data_length = 128;
int var_m, data_index, data[data_length];
unsigned char last_val;
void
print_received_bits (void)
{
  int i;
  if (GOOD_INDEX)
    for (i = 0; i < data_index - 1; i++)
      rt_printk ("%d\n", data[i]);
  else
    rt_printk ("ERROR : received more bits than buffer length...\n");
}


/* spectre gobals ----------------------------------------- */
RTIME spectre_clock_y;

int spectre_equals (RTIME a, RTIME b);
int spectre_largerthan (RTIME a, RTIME other);
int spectre_smallerthan (RTIME a, RTIME other);
RT_TASK spectre_task;
void spectre_task_main (int data);
void (*spectre_current_location) (void);
RTIME spectre_current_time;
int spectre_running;
void spectre_check_for_events (void);
int spectre_up_is_pending = 0;


/* variables readings headers ----------------------------- */
int spectre_read_m (void);
int spectre_read_r (void);

/* clocks readings headers -------------------------------- */
RTIME spectre_read_y (void);


/* variables writings headers ----------------------------- */
void spectre_write_m (int value);
void spectre_write_r (int value);

/* clocks writings headers -------------------------------- */
void spectre_write_y (RTIME value);


/* orders headers ----------------------------------------- */

/* internals headers -------------------------------------- */

/* events headers ----------------------------------------- */
int spectre_poll_up (void);
void spectre_d1_up (void);
void spectre_d2_up (void);

/* location headers --------------------------------------- */
void spectre_location_Idle (void);
void spectre_location_LastIsOne (void);
void spectre_location_LastIsZero (void);

/* transitions headers ------------------------------------ */
void spectre_transition_initially (void);
void spectre_transition_Idle_to_LastIsOne_1 (void);
void spectre_transition_LastIsOne_to_LastIsOne_1 (void);
void spectre_transition_LastIsOne_to_LastIsOne_2 (void);
void spectre_transition_LastIsOne_to_LastIsZero_3 (void);
void spectre_transition_LastIsOne_to_Idle_4 (void);
void spectre_transition_LastIsOne_to_Idle_5 (void);
void spectre_transition_LastIsZero_to_LastIsZero_1 (void);
void spectre_transition_LastIsZero_to_LastIsOne_2 (void);
void spectre_transition_LastIsZero_to_Idle_3 (void);

/* updates headers ---------------------------------------- */
void spectre_update_initially (void);
void spectre_update_Idle_to_LastIsOne_1 (void);
void spectre_update_LastIsOne_to_LastIsOne_1 (void);
void spectre_update_LastIsOne_to_LastIsOne_2 (void);
void spectre_update_LastIsOne_to_LastIsZero_3 (void);
void spectre_update_LastIsOne_to_Idle_4 (void);
void spectre_update_LastIsOne_to_Idle_5 (void);
void spectre_update_LastIsZero_to_LastIsZero_1 (void);
void spectre_update_LastIsZero_to_LastIsOne_2 (void);
void spectre_update_LastIsZero_to_Idle_3 (void);

/* guards headers ----------------------------------------- */
int spectre_guard_Idle_to_LastIsOne_1 (void);
int spectre_guard_LastIsOne_to_LastIsOne_1 (void);
int spectre_guard_LastIsOne_to_LastIsOne_2 (void);
int spectre_guard_LastIsOne_to_LastIsZero_3 (void);
int spectre_guard_LastIsOne_to_Idle_4 (void);
int spectre_guard_LastIsOne_to_Idle_5 (void);
int spectre_guard_LastIsZero_to_LastIsZero_1 (void);
int spectre_guard_LastIsZero_to_LastIsOne_2 (void);
int spectre_guard_LastIsZero_to_Idle_3 (void);

/* checks headers ----------------------------------------- */
int spectre_check_Idle_to_LastIsOne_1 (void);
int spectre_check_LastIsOne_to_LastIsOne_1 (void);
int spectre_check_LastIsOne_to_LastIsOne_2 (void);
int spectre_check_LastIsOne_to_LastIsZero_3 (void);
int spectre_check_LastIsOne_to_Idle_4 (void);
int spectre_check_LastIsOne_to_Idle_5 (void);
int spectre_check_LastIsZero_to_LastIsZero_1 (void);
int spectre_check_LastIsZero_to_LastIsOne_2 (void);
int spectre_check_LastIsZero_to_Idle_3 (void);

/* decorations headers ------------------------------------ */
void spectre_d1_Idle_to_LastIsOne (void);
void spectre_d1_LastIsOne_to_Idle (void);
void spectre_d1_LastIsOne_to_LastIsOne (void);
void spectre_d1_LastIsOne_to_LastIsZero (void);
void spectre_d1_LastIsZero_to_Idle (void);
void spectre_d1_LastIsZero_to_LastIsOne (void);
void spectre_d1_LastIsZero_to_LastIsZero (void);

void spectre_d2_Idle_to_LastIsOne (void);
void spectre_d2_LastIsOne_to_Idle (void);
void spectre_d2_LastIsOne_to_LastIsOne (void);
void spectre_d2_LastIsOne_to_LastIsZero (void);
void spectre_d2_LastIsZero_to_Idle (void);
void spectre_d2_LastIsZero_to_LastIsOne (void);
void spectre_d2_LastIsZero_to_LastIsZero (void);

void spectre_d1_any_to_Idle (void);
void spectre_d1_any_to_LastIsOne (void);
void spectre_d1_any_to_LastIsZero (void);

void spectre_d2_any_to_Idle (void);
void spectre_d2_any_to_LastIsOne (void);
void spectre_d2_any_to_LastIsZero (void);

void spectre_d1_Idle_to_any (void);
void spectre_d1_LastIsOne_to_any (void);
void spectre_d1_LastIsZero_to_any (void);

void spectre_d2_Idle_to_any (void);
void spectre_d2_LastIsOne_to_any (void);
void spectre_d2_LastIsZero_to_any (void);

void spectre_d1_any_to_any (void);
void spectre_d2_any_to_any (void);


/* restrictions headers ----------------------------------- */
int spectre_r_Idle_to_LastIsOne (void);
int spectre_r_LastIsOne_to_Idle (void);
int spectre_r_LastIsOne_to_LastIsOne (void);
int spectre_r_LastIsOne_to_LastIsZero (void);
int spectre_r_LastIsZero_to_Idle (void);
int spectre_r_LastIsZero_to_LastIsOne (void);
int spectre_r_LastIsZero_to_LastIsZero (void);

int spectre_r_any_to_Idle (void);
int spectre_r_any_to_LastIsOne (void);
int spectre_r_any_to_LastIsZero (void);

int spectre_r_Idle_to_any (void);
int spectre_r_LastIsOne_to_any (void);
int spectre_r_LastIsZero_to_any (void);

int spectre_r_any_to_any (void);

/* variables readings implementation ---------------------- */
int
spectre_read_m ()
{
  return var_m;
}

int
spectre_read_r ()
{
  return 0;
}

/* clocks readings implementation ------------------------- */
RTIME
spectre_read_y (void)
{
  return spectre_current_time - spectre_clock_y;
}


/* variables writings implementation ---------------------- */
void
spectre_write_m (int val)
{
  var_m = val;
}

void
spectre_write_r (int val)
{
  if (!GOOD_INDEX)
    return;
  switch (val)
    {
    case 0:
    case 1:
      data[data_index++] = val;
      break;
    case 2:
      data[data_index++] = 0;
      data[data_index++] = 1;
    }
}

/* clocks writings implementation ------------------------- */
void
spectre_write_y (RTIME newtime)
{
  spectre_clock_y = spectre_current_time - newtime;
}


/* decorations implementation ----------------------------- */
void
spectre_d1_Idle_to_LastIsOne ()
{;
}

void
spectre_d1_LastIsOne_to_Idle ()
{;
}

void
spectre_d1_LastIsOne_to_LastIsOne ()
{;
}

void
spectre_d1_LastIsOne_to_LastIsZero ()
{;
}

void
spectre_d1_LastIsZero_to_Idle ()
{;
}

void
spectre_d1_LastIsZero_to_LastIsOne ()
{;
}

void
spectre_d1_LastIsZero_to_LastIsZero ()
{;
}

void
spectre_d2_Idle_to_LastIsOne ()
{;
}

void
spectre_d2_LastIsOne_to_Idle ()
{;
}

void
spectre_d2_LastIsOne_to_LastIsOne ()
{;
}

void
spectre_d2_LastIsOne_to_LastIsZero ()
{;
}

void
spectre_d2_LastIsZero_to_Idle ()
{;
}

void
spectre_d2_LastIsZero_to_LastIsOne ()
{;
}

void
spectre_d2_LastIsZero_to_LastIsZero ()
{;
}

void
spectre_d1_any_to_Idle (void)
{
  spectre_running = 0;
}

void
spectre_d1_any_to_LastIsOne (void)
{;
}

void
spectre_d1_any_to_LastIsZero (void)
{;
}

void
spectre_d2_any_to_Idle (void)
{;
}

void
spectre_d2_any_to_LastIsOne (void)
{;
}

void
spectre_d2_any_to_LastIsZero (void)
{;
}

void
spectre_d1_Idle_to_any (void)
{;
}

void
spectre_d1_LastIsOne_to_any (void)
{;
}

void
spectre_d1_LastIsZero_to_any (void)
{;
}

void
spectre_d2_Idle_to_any (void)
{;
}

void
spectre_d2_LastIsOne_to_any (void)
{;
}

void
spectre_d2_LastIsZero_to_any (void)
{;
}

void
spectre_d1_any_to_any (void)
{;
}

void
spectre_d2_any_to_any (void)
{;
}


/* guards implementation ---------------------------------- */
int
spectre_guard_Idle_to_LastIsOne_1 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  return spectre_res;
}

int
spectre_guard_LastIsOne_to_LastIsOne_1 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = (TIME_UNIT * 3);
  spectre_t2 = spectre_read_y ();
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_t1 = spectre_read_y ();
  spectre_t2 = (TIME_UNIT * 5);
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_LastIsOne_to_LastIsOne_2 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = (TIME_UNIT * 7);
  spectre_t2 = spectre_read_y ();
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_LastIsOne_to_LastIsZero_3 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = (TIME_UNIT * 5);
  spectre_t2 = spectre_read_y ();
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_t1 = spectre_read_y ();
  spectre_t2 = (TIME_UNIT * 7);
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_LastIsOne_to_Idle_4 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = (TIME_UNIT * 9);
  spectre_t2 = spectre_read_y ();
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_e1 = spectre_read_m ();
  spectre_e2 = 0;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_LastIsOne_to_Idle_5 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = (TIME_UNIT * 9);
  spectre_t2 = spectre_read_y ();
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_e1 = spectre_read_m ();
  spectre_e2 = 1;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_LastIsZero_to_LastIsZero_1 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = (TIME_UNIT * 3);
  spectre_t2 = spectre_read_y ();
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_t1 = spectre_read_y ();
  spectre_t2 = (TIME_UNIT * 5);
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_LastIsZero_to_LastIsOne_2 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = (TIME_UNIT * 5);
  spectre_t2 = spectre_read_y ();
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_t1 = spectre_read_y ();
  spectre_t2 = (TIME_UNIT * 7);
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_LastIsZero_to_Idle_3 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = (TIME_UNIT * 7);
  spectre_t2 = spectre_read_y ();
  spectre_tmp = spectre_smallerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

/* restrictions implementation ---------------------------- */
int
spectre_r_Idle_to_LastIsOne (void)
{
  return 1;
}

int
spectre_r_LastIsOne_to_Idle (void)
{
  return 1;
}

int
spectre_r_LastIsOne_to_LastIsOne (void)
{
  return 1;
}

int
spectre_r_LastIsOne_to_LastIsZero (void)
{
  return 1;
}

int
spectre_r_LastIsZero_to_Idle (void)
{
  return 1;
}

int
spectre_r_LastIsZero_to_LastIsOne (void)
{
  return 1;
}

int
spectre_r_LastIsZero_to_LastIsZero (void)
{
  return 1;
}

int
spectre_r_any_to_Idle (void)
{
  return 1;
}

int
spectre_r_any_to_LastIsOne (void)
{
  return 1;
}

int
spectre_r_any_to_LastIsZero (void)
{
  return 1;
}

int
spectre_r_Idle_to_any (void)
{
  return 1;
}

int
spectre_r_LastIsOne_to_any (void)
{
  return 1;
}

int
spectre_r_LastIsZero_to_any (void)
{
  return 1;
}

int
spectre_r_any_to_any (void)
{
  return 1;
}

/* updates implementation --------------------------------- */
void
spectre_update_initially (void)
{
  spectre_write_y ((TIME_UNIT * 0));
  spectre_write_m (0);
}

void
spectre_update_Idle_to_LastIsOne_1 (void)
{
  spectre_write_y ((TIME_UNIT * 0));
  spectre_write_m (0);
}

void
spectre_update_LastIsOne_to_LastIsOne_1 (void)
{
  spectre_write_y ((TIME_UNIT * 0));
  spectre_write_m (1 - spectre_read_m ());
  spectre_write_r (1);
}

void
spectre_update_LastIsOne_to_LastIsOne_2 (void)
{
  spectre_write_y ((TIME_UNIT * 0));
  spectre_write_r (2);
}

void
spectre_update_LastIsOne_to_LastIsZero_3 (void)
{
  spectre_write_y ((TIME_UNIT * 0));
  spectre_write_m (1 - spectre_read_m ());
  spectre_write_r (0);
}

void
spectre_update_LastIsOne_to_Idle_4 (void)
{
  spectre_write_r (0);
}

void
spectre_update_LastIsOne_to_Idle_5 (void)
{
}
void
spectre_update_LastIsZero_to_LastIsZero_1 (void)
{
  spectre_write_y ((TIME_UNIT * 0));
  spectre_write_m (1 - spectre_read_m ());
  spectre_write_r (0);
}

void
spectre_update_LastIsZero_to_LastIsOne_2 (void)
{
  spectre_write_y ((TIME_UNIT * 0));
  spectre_write_r (2);
}

void
spectre_update_LastIsZero_to_Idle_3 (void)
{
  spectre_write_r (0);
}

/* orders implementation ---------------------------------- */

/* internals implementation ------------------------------- */

/* events implementation ---------------------------------- */
void
spectre_d1_up (void)
{;
}

void
spectre_d2_up (void)
{;
}

int
spectre_poll_up (void)
{
  unsigned char val = inb (DATA_REGISTER);
  return val == last_val ? 0 : (last_val = val);
}

/* checks implementation ---------------------------------- */
int
spectre_check_Idle_to_LastIsOne_1 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_Idle_to_LastIsOne ();
  spectre_r2 = spectre_r_Idle_to_any ();
  spectre_r3 = spectre_r_any_to_LastIsOne ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_Idle_to_LastIsOne_1 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4
	  && (spectre_up_is_pending == 1));
}

int
spectre_check_LastIsOne_to_LastIsOne_1 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_LastIsOne_to_LastIsOne ();
  spectre_r2 = spectre_r_LastIsOne_to_any ();
  spectre_r3 = spectre_r_any_to_LastIsOne ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_LastIsOne_to_LastIsOne_1 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4
	  && (spectre_up_is_pending == 1));
}

int
spectre_check_LastIsOne_to_LastIsOne_2 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_LastIsOne_to_LastIsOne ();
  spectre_r2 = spectre_r_LastIsOne_to_any ();
  spectre_r3 = spectre_r_any_to_LastIsOne ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_LastIsOne_to_LastIsOne_2 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4
	  && (spectre_up_is_pending == 1));
}

int
spectre_check_LastIsOne_to_LastIsZero_3 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_LastIsOne_to_LastIsZero ();
  spectre_r2 = spectre_r_LastIsOne_to_any ();
  spectre_r3 = spectre_r_any_to_LastIsZero ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_LastIsOne_to_LastIsZero_3 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4
	  && (spectre_up_is_pending == 1));
}

int
spectre_check_LastIsOne_to_Idle_4 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_LastIsOne_to_Idle ();
  spectre_r2 = spectre_r_LastIsOne_to_any ();
  spectre_r3 = spectre_r_any_to_Idle ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_LastIsOne_to_Idle_4 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_LastIsOne_to_Idle_5 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_LastIsOne_to_Idle ();
  spectre_r2 = spectre_r_LastIsOne_to_any ();
  spectre_r3 = spectre_r_any_to_Idle ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_LastIsOne_to_Idle_5 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_LastIsZero_to_LastIsZero_1 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_LastIsZero_to_LastIsZero ();
  spectre_r2 = spectre_r_LastIsZero_to_any ();
  spectre_r3 = spectre_r_any_to_LastIsZero ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_LastIsZero_to_LastIsZero_1 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4
	  && (spectre_up_is_pending == 1));
}

int
spectre_check_LastIsZero_to_LastIsOne_2 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_LastIsZero_to_LastIsOne ();
  spectre_r2 = spectre_r_LastIsZero_to_any ();
  spectre_r3 = spectre_r_any_to_LastIsOne ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_LastIsZero_to_LastIsOne_2 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4
	  && (spectre_up_is_pending == 1));
}

int
spectre_check_LastIsZero_to_Idle_3 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_LastIsZero_to_Idle ();
  spectre_r2 = spectre_r_LastIsZero_to_any ();
  spectre_r3 = spectre_r_any_to_Idle ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_LastIsZero_to_Idle_3 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

/* transitions implementation ----------------------------- */
void
spectre_transition_initially (void)
{
  spectre_update_initially ();
  spectre_current_location = spectre_location_Idle;
}

void
spectre_transition_Idle_to_LastIsOne_1 (void)
{
  spectre_d1_Idle_to_LastIsOne ();
  spectre_d1_Idle_to_any ();
  spectre_d1_any_to_LastIsOne ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_Idle_to_LastIsOne_1 ();
  spectre_current_location = spectre_location_LastIsOne;
  spectre_d2_up ();
  spectre_up_is_pending = 0;
  spectre_d2_Idle_to_LastIsOne ();
  spectre_d2_Idle_to_any ();
  spectre_d2_any_to_LastIsOne ();
  spectre_d2_any_to_any ();
}

void
spectre_transition_LastIsOne_to_LastIsOne_1 (void)
{
  spectre_d1_LastIsOne_to_LastIsOne ();
  spectre_d1_LastIsOne_to_any ();
  spectre_d1_any_to_LastIsOne ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_LastIsOne_to_LastIsOne_1 ();
  spectre_current_location = spectre_location_LastIsOne;
  spectre_d2_up ();
  spectre_up_is_pending = 0;
  spectre_d2_LastIsOne_to_LastIsOne ();
  spectre_d2_LastIsOne_to_any ();
  spectre_d2_any_to_LastIsOne ();
  spectre_d2_any_to_any ();
}

void
spectre_transition_LastIsOne_to_LastIsOne_2 (void)
{
  spectre_d1_LastIsOne_to_LastIsOne ();
  spectre_d1_LastIsOne_to_any ();
  spectre_d1_any_to_LastIsOne ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_LastIsOne_to_LastIsOne_2 ();
  spectre_current_location = spectre_location_LastIsOne;
  spectre_d2_up ();
  spectre_up_is_pending = 0;
  spectre_d2_LastIsOne_to_LastIsOne ();
  spectre_d2_LastIsOne_to_any ();
  spectre_d2_any_to_LastIsOne ();
  spectre_d2_any_to_any ();
}

void
spectre_transition_LastIsOne_to_LastIsZero_3 (void)
{
  spectre_d1_LastIsOne_to_LastIsZero ();
  spectre_d1_LastIsOne_to_any ();
  spectre_d1_any_to_LastIsZero ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_LastIsOne_to_LastIsZero_3 ();
  spectre_current_location = spectre_location_LastIsZero;
  spectre_d2_up ();
  spectre_up_is_pending = 0;
  spectre_d2_LastIsOne_to_LastIsZero ();
  spectre_d2_LastIsOne_to_any ();
  spectre_d2_any_to_LastIsZero ();
  spectre_d2_any_to_any ();
}

void
spectre_transition_LastIsOne_to_Idle_4 (void)
{
  spectre_d1_LastIsOne_to_Idle ();
  spectre_d1_LastIsOne_to_any ();
  spectre_d1_any_to_Idle ();
  spectre_d1_any_to_any ();
  spectre_update_LastIsOne_to_Idle_4 ();
  spectre_current_location = spectre_location_Idle;
  spectre_d2_LastIsOne_to_Idle ();
  spectre_d2_LastIsOne_to_any ();
  spectre_d2_any_to_Idle ();
  spectre_d2_any_to_any ();
}

void
spectre_transition_LastIsOne_to_Idle_5 (void)
{
  spectre_d1_LastIsOne_to_Idle ();
  spectre_d1_LastIsOne_to_any ();
  spectre_d1_any_to_Idle ();
  spectre_d1_any_to_any ();
  spectre_update_LastIsOne_to_Idle_5 ();
  spectre_current_location = spectre_location_Idle;
  spectre_d2_LastIsOne_to_Idle ();
  spectre_d2_LastIsOne_to_any ();
  spectre_d2_any_to_Idle ();
  spectre_d2_any_to_any ();
}

void
spectre_transition_LastIsZero_to_LastIsZero_1 (void)
{
  spectre_d1_LastIsZero_to_LastIsZero ();
  spectre_d1_LastIsZero_to_any ();
  spectre_d1_any_to_LastIsZero ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_LastIsZero_to_LastIsZero_1 ();
  spectre_current_location = spectre_location_LastIsZero;
  spectre_d2_up ();
  spectre_up_is_pending = 0;
  spectre_d2_LastIsZero_to_LastIsZero ();
  spectre_d2_LastIsZero_to_any ();
  spectre_d2_any_to_LastIsZero ();
  spectre_d2_any_to_any ();
}

void
spectre_transition_LastIsZero_to_LastIsOne_2 (void)
{
  spectre_d1_LastIsZero_to_LastIsOne ();
  spectre_d1_LastIsZero_to_any ();
  spectre_d1_any_to_LastIsOne ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_LastIsZero_to_LastIsOne_2 ();
  spectre_current_location = spectre_location_LastIsOne;
  spectre_d2_up ();
  spectre_up_is_pending = 0;
  spectre_d2_LastIsZero_to_LastIsOne ();
  spectre_d2_LastIsZero_to_any ();
  spectre_d2_any_to_LastIsOne ();
  spectre_d2_any_to_any ();
}

void
spectre_transition_LastIsZero_to_Idle_3 (void)
{
  spectre_d1_LastIsZero_to_Idle ();
  spectre_d1_LastIsZero_to_any ();
  spectre_d1_any_to_Idle ();
  spectre_d1_any_to_any ();
  spectre_update_LastIsZero_to_Idle_3 ();
  spectre_current_location = spectre_location_Idle;
  spectre_d2_LastIsZero_to_Idle ();
  spectre_d2_LastIsZero_to_any ();
  spectre_d2_any_to_Idle ();
  spectre_d2_any_to_any ();
}

/* location implementation -------------------------------- */
void
spectre_location_Idle (void)
{
  if (spectre_check_Idle_to_LastIsOne_1 ())
    {
      spectre_transition_Idle_to_LastIsOne_1 ();
      return;
    }
}

void
spectre_location_LastIsOne (void)
{
  if (spectre_check_LastIsOne_to_LastIsOne_1 ())
    {
      spectre_transition_LastIsOne_to_LastIsOne_1 ();
      return;
    }
  if (spectre_check_LastIsOne_to_LastIsOne_2 ())
    {
      spectre_transition_LastIsOne_to_LastIsOne_2 ();
      return;
    }
  if (spectre_check_LastIsOne_to_LastIsZero_3 ())
    {
      spectre_transition_LastIsOne_to_LastIsZero_3 ();
      return;
    }
  if (spectre_check_LastIsOne_to_Idle_4 ())
    {
      spectre_transition_LastIsOne_to_Idle_4 ();
      return;
    }
  if (spectre_check_LastIsOne_to_Idle_5 ())
    {
      spectre_transition_LastIsOne_to_Idle_5 ();
      return;
    }
}

void
spectre_location_LastIsZero (void)
{
  if (spectre_check_LastIsZero_to_LastIsZero_1 ())
    {
      spectre_transition_LastIsZero_to_LastIsZero_1 ();
      return;
    }
  if (spectre_check_LastIsZero_to_LastIsOne_2 ())
    {
      spectre_transition_LastIsZero_to_LastIsOne_2 ();
      return;
    }
  if (spectre_check_LastIsZero_to_Idle_3 ())
    {
      spectre_transition_LastIsZero_to_Idle_3 ();
      return;
    }
}

void
spectre_check_for_events (void)
{
  if ((spectre_up_is_pending == 0) && spectre_poll_up ())
    spectre_up_is_pending = 1;
}

void
spectre_cleanup (void)
{
  print_received_bits ();
}

void
spectre_startup (void)
{
  outb (32, CTRL_REGISTER);
  last_val = 0;
  data_index = 0;
}

int
spectre_equals (RTIME a, RTIME b)
{
  RTIME lower = b - WIDENER;
  RTIME higher = b + WIDENER;
  return (a > lower && a < higher);
}

int
spectre_largerthan (RTIME a, RTIME other)
{
  other -= WIDENER;
  return (a > other);
}

int
spectre_smallerthan (RTIME a, RTIME other)
{
  other += WIDENER;
  return (a < other);
}

/* main function implementation --------------------------- */
void
spectre_task_main (int data)
{
  spectre_running = 1;
  spectre_startup ();
  spectre_transition_initially ();
  while (spectre_running == 1)
    {
      spectre_current_time = rt_get_time ();
      spectre_check_for_events ();
      spectre_current_location ();
      rt_task_wait_period ();
    }
  spectre_cleanup ();
}

/* kernel module functions -------------------------------- */
int
spectre_init_module (void)
{
  rt_set_periodic_mode ();
  start_rt_timer (BEAT);
  rt_task_init (&spectre_task, spectre_task_main, 0, STACK_SIZE,
		TASK_PRIORITY, USE_FPU, 0);
  rt_task_make_periodic (&spectre_task, rt_get_time () + PERIOD, PERIOD);
  return 0;
}

void
spectre_cleanup_module (void)
{
  stop_rt_timer ();
  rt_task_delete (&spectre_task);
}

module_init (spectre_init_module);
module_exit (spectre_cleanup_module);
MODULE_LICENSE ("GPL");
