/* RTAI includes ------------------------------------------------------------ */
#include <linux/module.h>
#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_sem.h>
#include <rtai_fifos.h>

/* user defines ------------------------------------------------------------- */
#define TIME_UNIT   <define this>
#define WIDENER     <define this>
#define PERIOD      <define this>
#define BEAT        <define this>

/* system defines ----------------------------------------------------------- */
#define STACK_SIZE 10000
#define USE_FPU 1
#define TASK_PRIORITY 128	/* 0 = highest, 255 = lowest */

/* global decoration -------------------------------------------------------- */

#define DATA_REGISTER   0x378
#define CTRL_REGISTER   0x37A
#define GOOD_INDEX      (0 <= data_index && data_index < data_length)
int var_p, var_dz, data_index;
int data[] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 1,
  1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 1,
  1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 0, 1, 1,
  1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0
};
const int data_length = 8 * 8 + 2;
int
sequence_finished (void)
{
  return data_index >= data_length;
}


/* spectre gobals ----------------------------------------------------------- */
RTIME spectre_clock_x;

int spectre_equals (RTIME a, RTIME b);
int spectre_largerthan (RTIME a, RTIME other);
int spectre_smallerthan (RTIME a, RTIME other);
RT_TASK spectre_task;
void spectre_task_main (int data);
void (*spectre_current_location) (void);
RTIME spectre_current_time;
int spectre_running;
void spectre_check_for_events (void);


/* variables readings headers ----------------------------------------------- */
int spectre_read_i (void);
int spectre_read_p (void);
int spectre_read_dz (void);

/* clocks readings headers -------------------------------------------------- */
RTIME spectre_read_x (void);


/* variables writings headers ----------------------------------------------- */
void spectre_write_i (int value);
void spectre_write_p (int value);
void spectre_write_dz (int value);

/* clocks writings headers -------------------------------------------------- */
void spectre_write_x (RTIME value);


/* orders headers ----------------------------------------------------------- */
void spectre_d1_up (void);
void spectre_d1_down (void);
void spectre_d2_up (void);
void spectre_d2_down (void);

/* internals headers -------------------------------------------------------- */

/* events headers ----------------------------------------------------------- */

/* location headers --------------------------------------------------------- */
void spectre_location_Idle (void);
void spectre_location_OneSent (void);
void spectre_location_WaitOne (void);
void spectre_location_ZeroSent (void);
void spectre_location_WaitZero (void);

/* transitions headers ------------------------------------------------------ */
void spectre_transition_initially (void);
void spectre_transition_Idle_to_OneSent_1 (void);
void spectre_transition_OneSent_to_WaitOne_1 (void);
void spectre_transition_OneSent_to_ZeroSent_2 (void);
void spectre_transition_OneSent_to_Idle_3 (void);
void spectre_transition_WaitOne_to_OneSent_1 (void);
void spectre_transition_ZeroSent_to_WaitZero_1 (void);
void spectre_transition_ZeroSent_to_OneSent_2 (void);
void spectre_transition_ZeroSent_to_Idle_3 (void);
void spectre_transition_ZeroSent_to_Idle_4 (void);
void spectre_transition_WaitZero_to_ZeroSent_1 (void);

/* updates headers ---------------------------------------------------------- */
void spectre_update_initially (void);
void spectre_update_Idle_to_OneSent_1 (void);
void spectre_update_OneSent_to_WaitOne_1 (void);
void spectre_update_OneSent_to_ZeroSent_2 (void);
void spectre_update_OneSent_to_Idle_3 (void);
void spectre_update_WaitOne_to_OneSent_1 (void);
void spectre_update_ZeroSent_to_WaitZero_1 (void);
void spectre_update_ZeroSent_to_OneSent_2 (void);
void spectre_update_ZeroSent_to_Idle_3 (void);
void spectre_update_ZeroSent_to_Idle_4 (void);
void spectre_update_WaitZero_to_ZeroSent_1 (void);

/* guards headers ----------------------------------------------------------- */
int spectre_guard_Idle_to_OneSent_1 (void);
int spectre_guard_OneSent_to_WaitOne_1 (void);
int spectre_guard_OneSent_to_ZeroSent_2 (void);
int spectre_guard_OneSent_to_Idle_3 (void);
int spectre_guard_WaitOne_to_OneSent_1 (void);
int spectre_guard_ZeroSent_to_WaitZero_1 (void);
int spectre_guard_ZeroSent_to_OneSent_2 (void);
int spectre_guard_ZeroSent_to_Idle_3 (void);
int spectre_guard_ZeroSent_to_Idle_4 (void);
int spectre_guard_WaitZero_to_ZeroSent_1 (void);

/* checks headers ----------------------------------------------------------- */
int spectre_check_Idle_to_OneSent_1 (void);
int spectre_check_OneSent_to_WaitOne_1 (void);
int spectre_check_OneSent_to_ZeroSent_2 (void);
int spectre_check_OneSent_to_Idle_3 (void);
int spectre_check_WaitOne_to_OneSent_1 (void);
int spectre_check_ZeroSent_to_WaitZero_1 (void);
int spectre_check_ZeroSent_to_OneSent_2 (void);
int spectre_check_ZeroSent_to_Idle_3 (void);
int spectre_check_ZeroSent_to_Idle_4 (void);
int spectre_check_WaitZero_to_ZeroSent_1 (void);

/* decorations headers ------------------------------------------------------ */
void spectre_d1_Idle_to_OneSent (void);
void spectre_d1_OneSent_to_Idle (void);
void spectre_d1_OneSent_to_WaitOne (void);
void spectre_d1_OneSent_to_ZeroSent (void);
void spectre_d1_WaitOne_to_OneSent (void);
void spectre_d1_ZeroSent_to_Idle (void);
void spectre_d1_ZeroSent_to_OneSent (void);
void spectre_d1_ZeroSent_to_WaitZero (void);
void spectre_d1_WaitZero_to_ZeroSent (void);

void spectre_d2_Idle_to_OneSent (void);
void spectre_d2_OneSent_to_Idle (void);
void spectre_d2_OneSent_to_WaitOne (void);
void spectre_d2_OneSent_to_ZeroSent (void);
void spectre_d2_WaitOne_to_OneSent (void);
void spectre_d2_ZeroSent_to_Idle (void);
void spectre_d2_ZeroSent_to_OneSent (void);
void spectre_d2_ZeroSent_to_WaitZero (void);
void spectre_d2_WaitZero_to_ZeroSent (void);

void spectre_d1_any_to_Idle (void);
void spectre_d1_any_to_OneSent (void);
void spectre_d1_any_to_WaitOne (void);
void spectre_d1_any_to_ZeroSent (void);
void spectre_d1_any_to_WaitZero (void);

void spectre_d2_any_to_Idle (void);
void spectre_d2_any_to_OneSent (void);
void spectre_d2_any_to_WaitOne (void);
void spectre_d2_any_to_ZeroSent (void);
void spectre_d2_any_to_WaitZero (void);

void spectre_d1_Idle_to_any (void);
void spectre_d1_OneSent_to_any (void);
void spectre_d1_WaitOne_to_any (void);
void spectre_d1_ZeroSent_to_any (void);
void spectre_d1_WaitZero_to_any (void);

void spectre_d2_Idle_to_any (void);
void spectre_d2_OneSent_to_any (void);
void spectre_d2_WaitOne_to_any (void);
void spectre_d2_ZeroSent_to_any (void);
void spectre_d2_WaitZero_to_any (void);

void spectre_d1_any_to_any (void);
void spectre_d2_any_to_any (void);


/* restrictions headers ----------------------------------------------------- */
int spectre_r_Idle_to_OneSent (void);
int spectre_r_OneSent_to_Idle (void);
int spectre_r_OneSent_to_WaitOne (void);
int spectre_r_OneSent_to_ZeroSent (void);
int spectre_r_WaitOne_to_OneSent (void);
int spectre_r_ZeroSent_to_Idle (void);
int spectre_r_ZeroSent_to_OneSent (void);
int spectre_r_ZeroSent_to_WaitZero (void);
int spectre_r_WaitZero_to_ZeroSent (void);

int spectre_r_any_to_Idle (void);
int spectre_r_any_to_OneSent (void);
int spectre_r_any_to_WaitOne (void);
int spectre_r_any_to_ZeroSent (void);
int spectre_r_any_to_WaitZero (void);

int spectre_r_Idle_to_any (void);
int spectre_r_OneSent_to_any (void);
int spectre_r_WaitOne_to_any (void);
int spectre_r_ZeroSent_to_any (void);
int spectre_r_WaitZero_to_any (void);

int spectre_r_any_to_any (void);

/* variables readings implementation ---------------------------------------- */
int
spectre_read_i ()
{
  return GOOD_INDEX ? data[data_index] : 0;
}

int
spectre_read_p ()
{
  return var_p;
}

int
spectre_read_dz ()
{
  return var_dz;
}

/* clocks readings implementation ------------------------------------------- */
RTIME
spectre_read_x (void)
{
  return spectre_current_time - spectre_clock_x;
}


/* variables writings implementation ---------------------------------------- */
void
spectre_write_i (int foo)
{;
}

void
spectre_write_p (int value)
{
  var_p = value;
}

void
spectre_write_dz (int value)
{
  var_dz = value;
}

/* clocks writings implementation ------------------------------------------- */
void
spectre_write_x (RTIME newtime)
{
  spectre_clock_x = spectre_current_time - newtime;
}


/* decorations implementation ----------------------------------------------- */
void
spectre_d1_Idle_to_OneSent ()
{
  data_index = 0;
}

void
spectre_d1_OneSent_to_Idle ()
{;
}

void
spectre_d1_OneSent_to_WaitOne ()
{;
}

void
spectre_d1_OneSent_to_ZeroSent ()
{;
}

void
spectre_d1_WaitOne_to_OneSent ()
{
  data_index++;
}

void
spectre_d1_ZeroSent_to_Idle ()
{;
}

void
spectre_d1_ZeroSent_to_OneSent ()
{
  data_index++;
}

void
spectre_d1_ZeroSent_to_WaitZero ()
{;
}

void
spectre_d1_WaitZero_to_ZeroSent ()
{;
}

void
spectre_d2_Idle_to_OneSent ()
{;
}

void
spectre_d2_OneSent_to_Idle ()
{;
}

void
spectre_d2_OneSent_to_WaitOne ()
{;
}

void
spectre_d2_OneSent_to_ZeroSent ()
{;
}

void
spectre_d2_WaitOne_to_OneSent ()
{;
}

void
spectre_d2_ZeroSent_to_Idle ()
{;
}

void
spectre_d2_ZeroSent_to_OneSent ()
{;
}

void
spectre_d2_ZeroSent_to_WaitZero ()
{;
}

void
spectre_d2_WaitZero_to_ZeroSent ()
{;
}

void
spectre_d1_any_to_Idle (void)
{
  spectre_running = 0;
}

void
spectre_d1_any_to_OneSent (void)
{;
}

void
spectre_d1_any_to_WaitOne (void)
{;
}

void
spectre_d1_any_to_ZeroSent (void)
{
  data_index++;
}

void
spectre_d1_any_to_WaitZero (void)
{;
}

void
spectre_d2_any_to_Idle (void)
{;
}

void
spectre_d2_any_to_OneSent (void)
{;
}

void
spectre_d2_any_to_WaitOne (void)
{;
}

void
spectre_d2_any_to_ZeroSent (void)
{;
}

void
spectre_d2_any_to_WaitZero (void)
{;
}

void
spectre_d1_Idle_to_any (void)
{;
}

void
spectre_d1_OneSent_to_any (void)
{;
}

void
spectre_d1_WaitOne_to_any (void)
{;
}

void
spectre_d1_ZeroSent_to_any (void)
{;
}

void
spectre_d1_WaitZero_to_any (void)
{;
}

void
spectre_d2_Idle_to_any (void)
{;
}

void
spectre_d2_OneSent_to_any (void)
{;
}

void
spectre_d2_WaitOne_to_any (void)
{;
}

void
spectre_d2_ZeroSent_to_any (void)
{;
}

void
spectre_d2_WaitZero_to_any (void)
{;
}

void
spectre_d1_any_to_any (void)
{;
}

void
spectre_d2_any_to_any (void)
{;
}


/* guards implementation ---------------------------------------------------- */
int
spectre_guard_Idle_to_OneSent_1 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (TIME_UNIT * 12);
  spectre_tmp = spectre_largerthan (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_OneSent_to_WaitOne_1 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (TIME_UNIT * 2);
  spectre_tmp = spectre_equals (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_e1 = spectre_read_i ();
  spectre_e2 = 1;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_OneSent_to_ZeroSent_2 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (TIME_UNIT * 4);
  spectre_tmp = spectre_equals (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_e1 = spectre_read_i ();
  spectre_e2 = 0;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_OneSent_to_Idle_3 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_e1 = spectre_read_p ();
  spectre_e2 = 1;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_WaitOne_to_OneSent_1 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (TIME_UNIT * 2);
  spectre_tmp = spectre_equals (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_ZeroSent_to_WaitZero_1 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (TIME_UNIT * 2);
  spectre_tmp = spectre_equals (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_e1 = spectre_read_i ();
  spectre_e2 = 0;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_ZeroSent_to_OneSent_2 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (TIME_UNIT * 4);
  spectre_tmp = spectre_equals (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  spectre_e1 = spectre_read_i ();
  spectre_e2 = 1;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_ZeroSent_to_Idle_3 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_e1 = spectre_read_p ();
  spectre_e2 = 1;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_ZeroSent_to_Idle_4 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_e1 = spectre_read_dz ();
  spectre_e2 = 1;
  spectre_tmp = spectre_e1 == spectre_e2;
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

int
spectre_guard_WaitZero_to_ZeroSent_1 (void)
{
  RTIME spectre_t1, spectre_t2;
  int spectre_e1, spectre_e2;
  int spectre_res = 1, spectre_tmp;
  spectre_t1 = spectre_read_x ();
  spectre_t2 = (TIME_UNIT * 2);
  spectre_tmp = spectre_equals (spectre_t1, spectre_t2);
  spectre_res = spectre_tmp && spectre_res;
  return spectre_res;
}

/* restrictions implementation ---------------------------------------------- */
int
spectre_r_Idle_to_OneSent (void)
{
  return 1;
}

int
spectre_r_OneSent_to_Idle (void)
{
  return 1;
}

int
spectre_r_OneSent_to_WaitOne (void)
{
  return 1;
}

int
spectre_r_OneSent_to_ZeroSent (void)
{
  return 1;
}

int
spectre_r_WaitOne_to_OneSent (void)
{
  return 1;
}

int
spectre_r_ZeroSent_to_Idle (void)
{
  return 1;
}

int
spectre_r_ZeroSent_to_OneSent (void)
{
  return 1;
}

int
spectre_r_ZeroSent_to_WaitZero (void)
{
  return 1;
}

int
spectre_r_WaitZero_to_ZeroSent (void)
{
  return 1;
}

int
spectre_r_any_to_Idle (void)
{
  return sequence_finished ();
}

int
spectre_r_any_to_OneSent (void)
{
  return 1;
}

int
spectre_r_any_to_WaitOne (void)
{
  return !sequence_finished ();
}

int
spectre_r_any_to_ZeroSent (void)
{
  return !sequence_finished ();
}

int
spectre_r_any_to_WaitZero (void)
{
  return !sequence_finished ();
}

int
spectre_r_Idle_to_any (void)
{
  return 1;
}

int
spectre_r_OneSent_to_any (void)
{
  return 1;
}

int
spectre_r_WaitOne_to_any (void)
{
  return 1;
}

int
spectre_r_ZeroSent_to_any (void)
{
  return 1;
}

int
spectre_r_WaitZero_to_any (void)
{
  return 1;
}

int
spectre_r_any_to_any (void)
{
  return 1;
}

/* updates implementation --------------------------------------------------- */
void
spectre_update_initially (void)
{
  spectre_write_x ((TIME_UNIT * 0));
  spectre_write_p (0);
  spectre_write_dz (0);
}

void
spectre_update_Idle_to_OneSent_1 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
  spectre_write_p (0);
  spectre_write_dz (0);
}

void
spectre_update_OneSent_to_WaitOne_1 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
}

void
spectre_update_OneSent_to_ZeroSent_2 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
  spectre_write_p (1 - spectre_read_p ());
}

void
spectre_update_OneSent_to_Idle_3 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
}

void
spectre_update_WaitOne_to_OneSent_1 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
  spectre_write_p (1 - spectre_read_p ());
}

void
spectre_update_ZeroSent_to_WaitZero_1 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
}

void
spectre_update_ZeroSent_to_OneSent_2 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
  spectre_write_p (1 - spectre_read_p ());
  spectre_write_dz (0);
}

void
spectre_update_ZeroSent_to_Idle_3 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
}

void
spectre_update_ZeroSent_to_Idle_4 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
}

void
spectre_update_WaitZero_to_ZeroSent_1 (void)
{
  spectre_write_x ((TIME_UNIT * 0));
  spectre_write_p (1 - spectre_read_p ());
  spectre_write_dz (1);
}

/* orders implementation ---------------------------------------------------- */
void
spectre_d1_up (void)
{
  outb (255, DATA_REGISTER);
}

void
spectre_d1_down (void)
{
  outb (0, DATA_REGISTER);
}

void
spectre_d2_up (void)
{;
}

void
spectre_d2_down (void)
{;
}

/* internals implementation ------------------------------------------------- */

/* events implementation ---------------------------------------------------- */

/* checks implementation ---------------------------------------------------- */
int
spectre_check_Idle_to_OneSent_1 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_Idle_to_OneSent ();
  spectre_r2 = spectre_r_Idle_to_any ();
  spectre_r3 = spectre_r_any_to_OneSent ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_Idle_to_OneSent_1 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_OneSent_to_WaitOne_1 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_OneSent_to_WaitOne ();
  spectre_r2 = spectre_r_OneSent_to_any ();
  spectre_r3 = spectre_r_any_to_WaitOne ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_OneSent_to_WaitOne_1 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_OneSent_to_ZeroSent_2 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_OneSent_to_ZeroSent ();
  spectre_r2 = spectre_r_OneSent_to_any ();
  spectre_r3 = spectre_r_any_to_ZeroSent ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_OneSent_to_ZeroSent_2 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_OneSent_to_Idle_3 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_OneSent_to_Idle ();
  spectre_r2 = spectre_r_OneSent_to_any ();
  spectre_r3 = spectre_r_any_to_Idle ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_OneSent_to_Idle_3 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_WaitOne_to_OneSent_1 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_WaitOne_to_OneSent ();
  spectre_r2 = spectre_r_WaitOne_to_any ();
  spectre_r3 = spectre_r_any_to_OneSent ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_WaitOne_to_OneSent_1 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_ZeroSent_to_WaitZero_1 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_ZeroSent_to_WaitZero ();
  spectre_r2 = spectre_r_ZeroSent_to_any ();
  spectre_r3 = spectre_r_any_to_WaitZero ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_ZeroSent_to_WaitZero_1 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_ZeroSent_to_OneSent_2 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_ZeroSent_to_OneSent ();
  spectre_r2 = spectre_r_ZeroSent_to_any ();
  spectre_r3 = spectre_r_any_to_OneSent ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_ZeroSent_to_OneSent_2 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_ZeroSent_to_Idle_3 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_ZeroSent_to_Idle ();
  spectre_r2 = spectre_r_ZeroSent_to_any ();
  spectre_r3 = spectre_r_any_to_Idle ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_ZeroSent_to_Idle_3 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_ZeroSent_to_Idle_4 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_ZeroSent_to_Idle ();
  spectre_r2 = spectre_r_ZeroSent_to_any ();
  spectre_r3 = spectre_r_any_to_Idle ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_ZeroSent_to_Idle_4 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

int
spectre_check_WaitZero_to_ZeroSent_1 (void)
{
  int spectre_r1, spectre_r2, spectre_r3, spectre_r4, spectre_g;
  spectre_r1 = spectre_r_WaitZero_to_ZeroSent ();
  spectre_r2 = spectre_r_WaitZero_to_any ();
  spectre_r3 = spectre_r_any_to_ZeroSent ();
  spectre_r4 = spectre_r_any_to_any ();
  spectre_g = spectre_guard_WaitZero_to_ZeroSent_1 ();
  return (spectre_g && spectre_r1 && spectre_r2 && spectre_r3 && spectre_r4);
}

/* transitions implementation ----------------------------------------------- */
void
spectre_transition_initially (void)
{
  spectre_update_initially ();
  spectre_current_location = spectre_location_Idle;
}

void
spectre_transition_Idle_to_OneSent_1 (void)
{
  spectre_d1_Idle_to_OneSent ();
  spectre_d1_Idle_to_any ();
  spectre_d1_any_to_OneSent ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_Idle_to_OneSent_1 ();
  spectre_d2_up ();
  spectre_d2_Idle_to_OneSent ();
  spectre_d2_Idle_to_any ();
  spectre_d2_any_to_OneSent ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_OneSent;
}

void
spectre_transition_OneSent_to_WaitOne_1 (void)
{
  spectre_d1_OneSent_to_WaitOne ();
  spectre_d1_OneSent_to_any ();
  spectre_d1_any_to_WaitOne ();
  spectre_d1_any_to_any ();
  spectre_d1_down ();
  spectre_update_OneSent_to_WaitOne_1 ();
  spectre_d2_down ();
  spectre_d2_OneSent_to_WaitOne ();
  spectre_d2_OneSent_to_any ();
  spectre_d2_any_to_WaitOne ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_WaitOne;
}

void
spectre_transition_OneSent_to_ZeroSent_2 (void)
{
  spectre_d1_OneSent_to_ZeroSent ();
  spectre_d1_OneSent_to_any ();
  spectre_d1_any_to_ZeroSent ();
  spectre_d1_any_to_any ();
  spectre_d1_down ();
  spectre_update_OneSent_to_ZeroSent_2 ();
  spectre_d2_down ();
  spectre_d2_OneSent_to_ZeroSent ();
  spectre_d2_OneSent_to_any ();
  spectre_d2_any_to_ZeroSent ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_ZeroSent;
}

void
spectre_transition_OneSent_to_Idle_3 (void)
{
  spectre_d1_OneSent_to_Idle ();
  spectre_d1_OneSent_to_any ();
  spectre_d1_any_to_Idle ();
  spectre_d1_any_to_any ();
  spectre_d1_down ();
  spectre_update_OneSent_to_Idle_3 ();
  spectre_d2_down ();
  spectre_d2_OneSent_to_Idle ();
  spectre_d2_OneSent_to_any ();
  spectre_d2_any_to_Idle ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_Idle;
}

void
spectre_transition_WaitOne_to_OneSent_1 (void)
{
  spectre_d1_WaitOne_to_OneSent ();
  spectre_d1_WaitOne_to_any ();
  spectre_d1_any_to_OneSent ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_WaitOne_to_OneSent_1 ();
  spectre_d2_up ();
  spectre_d2_WaitOne_to_OneSent ();
  spectre_d2_WaitOne_to_any ();
  spectre_d2_any_to_OneSent ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_OneSent;
}

void
spectre_transition_ZeroSent_to_WaitZero_1 (void)
{
  spectre_d1_ZeroSent_to_WaitZero ();
  spectre_d1_ZeroSent_to_any ();
  spectre_d1_any_to_WaitZero ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_ZeroSent_to_WaitZero_1 ();
  spectre_d2_up ();
  spectre_d2_ZeroSent_to_WaitZero ();
  spectre_d2_ZeroSent_to_any ();
  spectre_d2_any_to_WaitZero ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_WaitZero;
}

void
spectre_transition_ZeroSent_to_OneSent_2 (void)
{
  spectre_d1_ZeroSent_to_OneSent ();
  spectre_d1_ZeroSent_to_any ();
  spectre_d1_any_to_OneSent ();
  spectre_d1_any_to_any ();
  spectre_d1_up ();
  spectre_update_ZeroSent_to_OneSent_2 ();
  spectre_d2_up ();
  spectre_d2_ZeroSent_to_OneSent ();
  spectre_d2_ZeroSent_to_any ();
  spectre_d2_any_to_OneSent ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_OneSent;
}

void
spectre_transition_ZeroSent_to_Idle_3 (void)
{
  spectre_d1_ZeroSent_to_Idle ();
  spectre_d1_ZeroSent_to_any ();
  spectre_d1_any_to_Idle ();
  spectre_d1_any_to_any ();
  spectre_d1_down ();
  spectre_update_ZeroSent_to_Idle_3 ();
  spectre_d2_down ();
  spectre_d2_ZeroSent_to_Idle ();
  spectre_d2_ZeroSent_to_any ();
  spectre_d2_any_to_Idle ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_Idle;
}

void
spectre_transition_ZeroSent_to_Idle_4 (void)
{
  spectre_d1_ZeroSent_to_Idle ();
  spectre_d1_ZeroSent_to_any ();
  spectre_d1_any_to_Idle ();
  spectre_d1_any_to_any ();
  spectre_d1_down ();
  spectre_update_ZeroSent_to_Idle_4 ();
  spectre_d2_down ();
  spectre_d2_ZeroSent_to_Idle ();
  spectre_d2_ZeroSent_to_any ();
  spectre_d2_any_to_Idle ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_Idle;
}

void
spectre_transition_WaitZero_to_ZeroSent_1 (void)
{
  spectre_d1_WaitZero_to_ZeroSent ();
  spectre_d1_WaitZero_to_any ();
  spectre_d1_any_to_ZeroSent ();
  spectre_d1_any_to_any ();
  spectre_d1_down ();
  spectre_update_WaitZero_to_ZeroSent_1 ();
  spectre_d2_down ();
  spectre_d2_WaitZero_to_ZeroSent ();
  spectre_d2_WaitZero_to_any ();
  spectre_d2_any_to_ZeroSent ();
  spectre_d2_any_to_any ();
  spectre_current_location = spectre_location_ZeroSent;
}

/* location implementation -------------------------------------------------- */
void
spectre_location_Idle (void)
{
  if (spectre_check_Idle_to_OneSent_1 ())
    spectre_transition_Idle_to_OneSent_1 ();
}

void
spectre_location_OneSent (void)
{
  if (spectre_check_OneSent_to_WaitOne_1 ())
    spectre_transition_OneSent_to_WaitOne_1 ();
  if (spectre_check_OneSent_to_ZeroSent_2 ())
    spectre_transition_OneSent_to_ZeroSent_2 ();
  if (spectre_check_OneSent_to_Idle_3 ())
    spectre_transition_OneSent_to_Idle_3 ();
}

void
spectre_location_WaitOne (void)
{
  if (spectre_check_WaitOne_to_OneSent_1 ())
    spectre_transition_WaitOne_to_OneSent_1 ();
}

void
spectre_location_ZeroSent (void)
{
  if (spectre_check_ZeroSent_to_WaitZero_1 ())
    spectre_transition_ZeroSent_to_WaitZero_1 ();
  if (spectre_check_ZeroSent_to_OneSent_2 ())
    spectre_transition_ZeroSent_to_OneSent_2 ();
  if (spectre_check_ZeroSent_to_Idle_3 ())
    spectre_transition_ZeroSent_to_Idle_3 ();
  if (spectre_check_ZeroSent_to_Idle_4 ())
    spectre_transition_ZeroSent_to_Idle_4 ();
}

void
spectre_location_WaitZero (void)
{
  if (spectre_check_WaitZero_to_ZeroSent_1 ())
    spectre_transition_WaitZero_to_ZeroSent_1 ();
}

void
spectre_check_for_events (void)
{
}
void
spectre_cleanup (void)
{;
}

void
spectre_startup (void)
{
  outb (0, CTRL_REGISTER);
  outb (0, DATA_REGISTER);
}

int
spectre_equals (RTIME a, RTIME b)
{
  RTIME lower = b - WIDENER;
  RTIME higher = b + WIDENER;
  return (a > lower && a < higher);
}

int
spectre_largerthan (RTIME a, RTIME other)
{
  other -= WIDENER;
  return (a > other);
}

int
spectre_smallerthan (RTIME a, RTIME other)
{
  other += WIDENER;
  return (a < other);
}

/* main function implementation --------------------------------------------- */
void
spectre_task_main (int data)
{
  spectre_running = 1;
  spectre_startup ();
  spectre_transition_initially ();
  while (spectre_running == 1)
    {
      spectre_current_time = rt_get_time ();
      spectre_check_for_events ();
      spectre_current_location ();
      rt_task_wait_period ();
    }
  spectre_cleanup ();
}

/* kernel module functions -------------------------------------------------- */
int
spectre_init_module (void)
{
  rt_set_periodic_mode ();
  start_rt_timer (BEAT);
  rt_task_init (&spectre_task, spectre_task_main, 0, STACK_SIZE,
		TASK_PRIORITY, USE_FPU, 0);
  rt_task_make_periodic (&spectre_task, rt_get_time () + PERIOD, PERIOD);
  return 0;
}

void
spectre_cleanup_module (void)
{
  stop_rt_timer ();
  rt_task_delete (&spectre_task);
}

module_init (spectre_init_module);
module_exit (spectre_cleanup_module);
MODULE_LICENSE ("GPL");
